#include "BoundTracker.h"

BoundTracker::BoundTracker(std::shared_ptr<int> lastKey, std::shared_ptr<UI> ui) {
	BoundTracker::lastKey = lastKey;
	BoundTracker::ui = ui;
}

void BoundTracker::init(cv::Rect2d roi) {
	BoundTracker::roi = roi;
	tracker->init(ui->getOriginalFrame(), BoundTracker::roi);
}

bool BoundTracker::track() {
	tracker->update(ui->getOriginalFrame(), roi);

	if ((roi.x < 0) || (roi.x + roi.width > ui->getWidth()) || (roi.y < 0) || (roi.y + roi.height > ui->getHeight())) {
		return false;
	} else {
		for (unsigned i = 0; i < deadConsistency.size(); i++) {
			if ((roi & deadConsistency.back()).area() != roi.area() || deadConsistency.size() < queueSize) {
				break;
			}
			return false;
		}

		deadConsistency.push_back(roi);
		if (deadConsistency.size() > queueSize) {
			deadConsistency.pop_front();
		}
		return true;
	}
}

void BoundTracker::setROI(cv::Rect2d roi) {
	BoundTracker::roi = roi;
}

cv::Rect2d BoundTracker::getROI() const {
	return roi;
}

BoundTracker::~BoundTracker() {
}

